Index: kernel/arch/ia64/include/mm/as.h
===================================================================
--- kernel/arch/ia64/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -38,10 +38,10 @@
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH  ((unsigned long) 0xe000000000000000ULL)
-#define KERNEL_ADDRESS_SPACE_END_ARCH    ((unsigned long) 0xffffffffffffffffULL)
-#define USER_ADDRESS_SPACE_START_ARCH    ((unsigned long) 0x0000000000000000ULL)
-#define USER_ADDRESS_SPACE_END_ARCH      ((unsigned long) 0xdfffffffffffffffULL)
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0xe000000000000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT64_C(0xffffffffffffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT64_C(0x0000000000000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT64_C(0xdfffffffffffffff)
 
-#define USTACK_ADDRESS_ARCH  0x0000000ff0000000ULL
+#define USTACK_ADDRESS_ARCH  UINT64_C(0x0000000ff0000000)
 
 typedef struct {
Index: kernel/arch/ia64/include/mm/frame.h
===================================================================
--- kernel/arch/ia64/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,5 +39,4 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
 
@@ -49,8 +48,5 @@
 #define physmem_print()
 
-#define ARCH_STACK_FRAMES TWO_FRAMES
-
 #endif /* __ASM__ */
-#endif /* KERNEL */
 
 #endif
Index: kernel/arch/ia64/include/mm/page.h
===================================================================
--- kernel/arch/ia64/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -41,6 +41,4 @@
 #define PAGE_SIZE   FRAME_SIZE
 #define PAGE_WIDTH  FRAME_WIDTH
-
-#ifdef KERNEL
 
 /** Bit width of the TLB-locked portion of kernel address space. */
@@ -316,6 +314,4 @@
 #endif /* __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/ia64/include/register.h
===================================================================
--- kernel/arch/ia64/include/register.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/include/register.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -60,4 +60,7 @@
 #define PSR_CPL_SHIFT         32
 #define PSR_CPL_MASK_SHIFTED  3
+
+#define PSR_RI_SHIFT  41
+#define PSR_RI_LEN    2
 
 #define PFM_MASK  (~0x3fffffffff)
@@ -142,10 +145,4 @@
 #ifndef __ASM__
 
-#ifdef KERNEL
-#include <typedefs.h>
-#else
-#include <sys/types.h>
-#endif
-
 /** Processor Status Register. */
 typedef union {
Index: kernel/arch/ia64/include/types.h
===================================================================
--- kernel/arch/ia64/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,4 +37,5 @@
 
 typedef uint64_t size_t;
+typedef int64_t ssize_t;
 
 typedef uint64_t uintptr_t;
Index: kernel/arch/ia64/src/asm.S
===================================================================
--- kernel/arch/ia64/src/asm.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/asm.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -30,5 +30,4 @@
 
 .text
-.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
@@ -39,5 +38,6 @@
  *
  * This memcpy() has been taken from the assembler output of
- * the generic _memcpy() and modified to have the failover part.
+ * a plain C implementation of memcpy() modified to have the
+ * failover part.
  *
  * @param in0 Destination address.
@@ -46,5 +46,4 @@
  *
  */
-memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
@@ -141,12 +140,4 @@
 	br.ret.sptk.many rp
 
-.global memsetb
-memsetb:
-	br _memsetb
-
-.global memsetw
-memsetw:
-	br _memsetw
-
 .global cpu_halt
 cpu_halt:
Index: kernel/arch/ia64/src/drivers/ski.c
===================================================================
--- kernel/arch/ia64/src/drivers/ski.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/drivers/ski.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -57,5 +57,5 @@
 };
 
-static void ski_putchar(outdev_t *, const wchar_t, bool);
+static void ski_putchar(outdev_t *, const wchar_t);
 
 static outdev_operations_t skidev_ops = {
@@ -99,7 +99,4 @@
 static void poll_keyboard(ski_instance_t *instance)
 {
-	if (silent)
-		return;
-	
 	int count = POLL_LIMIT;
 	
@@ -121,5 +118,8 @@
 	
 	while (true) {
-		if (!silent)
+		// TODO FIXME:
+		// This currently breaks the kernel console
+		// before we get the override from uspace.
+		if (console_override)
 			poll_keyboard(instance);
 		
@@ -182,10 +182,12 @@
  * @param dev    Character device.
  * @param ch     Character to be printed.
- * @param silent Whether the output should be silenced.
- *
- */
-static void ski_putchar(outdev_t *dev, const wchar_t ch, bool silent)
-{
-	if (!silent) {
+ *
+ */
+static void ski_putchar(outdev_t *dev, const wchar_t ch)
+{
+	// TODO FIXME:
+	// This currently breaks the kernel console
+	// before we get the override from uspace.
+	if (console_override) {
 		if (ascii_check(ch)) {
 			if (ch == '\n')
@@ -213,5 +215,6 @@
 	if (!fb_exported) {
 		/*
-		 * This is the necessary evil until the userspace driver is entirely
+		 * This is the necessary evil until
+		 * the userspace driver is entirely
 		 * self-sufficient.
 		 */
Index: kernel/arch/ia64/src/ia64.c
===================================================================
--- kernel/arch/ia64/src/ia64.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/ia64.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -50,5 +50,5 @@
 #include <userspace.h>
 #include <console/console.h>
-#include <proc/uarg.h>
+#include <abi/proc/uarg.h>
 #include <syscall/syscall.h>
 #include <ddi/irq.h>
@@ -151,5 +151,5 @@
 	/* Set platform name. */
 #ifdef MACHINE_ski
-	platform = "pc";
+	platform = "ski";
 #endif
 #ifdef MACHINE_i460GX
@@ -249,8 +249,14 @@
 	rsc.mode = 3;			/* eager mode */
 
+	/*
+	 * Switch to userspace.
+	 *
+	 * When calculating stack addresses, mind the stack split between the
+	 * memory stack and the RSE stack. Each occuppies STACK_SIZE / 2 bytes.
+	 */
 	switch_to_userspace((uintptr_t) kernel_uarg->uspace_entry,
-	    ((uintptr_t) kernel_uarg->uspace_stack) + PAGE_SIZE -
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE / 2 -
 	    ALIGN_UP(STACK_ITEM_SIZE, STACK_ALIGNMENT),
-	    ((uintptr_t) kernel_uarg->uspace_stack) + PAGE_SIZE,
+	    ((uintptr_t) kernel_uarg->uspace_stack) + STACK_SIZE / 2,
 	    (uintptr_t) kernel_uarg->uspace_uarg, psr.value, rsc.value);
 
Index: kernel/arch/ia64/src/ivt.S
===================================================================
--- kernel/arch/ia64/src/ivt.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/ivt.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -50,4 +50,39 @@
 #define R_KSTACK_BSP	r22	/* keep in sync with before_thread_runs_arch() */
 #define R_KSTACK	r23	/* keep in sync with before_thread_runs_arch() */
+
+/* Speculation vector handler */
+.macro SPECULATION_VECTOR_HANDLER offs
+    .org ivt + \offs
+
+    /* 1. Save predicates, IIM, IIP, IPSR and ISR CR's in bank 0 registers. */
+	mov r16 = pr
+	mov r17 = cr.iim
+	mov r18 = cr.iip
+	mov r19 = cr.ipsr
+	mov r20 = cr.isr ;;
+	
+    /* 2. Move IIP to IIPA. */
+	mov cr.iipa = r18
+	
+    /* 3. Sign extend IIM[20:0], shift left by 4 and add to IIP. */
+	shl r17 = r17, 43 ;;	/* shift bit 20 to bit 63 */
+	shr r17 = r17, 39 ;;	/* signed shift right to bit 24 */
+	add r18 = r18, r17 ;;
+	mov cr.iip = r18
+	
+    /* 4. Set IPSR.ri to 0. */
+	dep r19 = 0, r19, PSR_RI_SHIFT, PSR_RI_LEN ;;
+	mov cr.ipsr = r19
+	
+    /* 5. Check whether IPSR.tb or IPSR.ss is set. */
+
+	/* TODO:
+	 * Implement this when Taken Branch and Single Step traps can occur.
+	 */
+    
+    /* 6. Restore predicates and return from interruption. */
+	mov pr = r16 ;;
+	rfi
+.endm
 
 /** Heavyweight interrupt handler
@@ -391,5 +426,5 @@
 
     /* 10. call handler */
-    	movl r1 = kernel_image_start
+    	movl r1 = __gp
     
     	mov b1 = loc2
@@ -541,5 +576,5 @@
 	HEAVYWEIGHT_HANDLER 0x5500 disabled_fp_register
 	HEAVYWEIGHT_HANDLER 0x5600
-	HEAVYWEIGHT_HANDLER 0x5700
+	SPECULATION_VECTOR_HANDLER 0x5700
 	HEAVYWEIGHT_HANDLER 0x5800
 	HEAVYWEIGHT_HANDLER 0x5900
Index: kernel/arch/ia64/src/mm/frame.c
===================================================================
--- kernel/arch/ia64/src/mm/frame.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/mm/frame.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -58,5 +58,5 @@
 		unsigned int i;
 		for (i = 0; i < bootinfo->memmap_items; i++) {
-			if (bootinfo->memmap[i].type == EFI_MEMMAP_FREE_MEM) {
+			if (bootinfo->memmap[i].type == MEMMAP_FREE_MEM) {
 				uint64_t base = bootinfo->memmap[i].base;
 				uint64_t size = bootinfo->memmap[i].size;
Index: kernel/arch/ia64/src/mm/tlb.c
===================================================================
--- kernel/arch/ia64/src/mm/tlb.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/mm/tlb.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -475,15 +475,11 @@
 void alternate_instruction_tlb_fault(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa; /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	if (t) {
 		/*
@@ -603,5 +599,5 @@
 	
 	page_table_lock(AS, true);
-	pte_t *entry = page_mapping_find(AS, va);
+	pte_t *entry = page_mapping_find(AS, va, true);
 	if (entry) {
 		/*
@@ -649,15 +645,11 @@
 void data_dirty_bit_fault(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	ASSERT((t) && (t->p));
 	if ((t) && (t->p) && (t->w)) {
@@ -686,15 +678,11 @@
 void instruction_access_bit_fault(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	ASSERT((t) && (t->p));
 	if ((t) && (t->p) && (t->x)) {
@@ -723,15 +711,11 @@
 void data_access_bit_fault(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	ASSERT((t) && (t->p));
 	if ((t) && (t->p)) {
@@ -760,12 +744,8 @@
 void data_access_rights_fault(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	/*
@@ -773,5 +753,5 @@
 	 */
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	ASSERT((t) && (t->p));
 	ASSERT(!t->w);
@@ -792,15 +772,11 @@
 void page_not_present(uint64_t vector, istate_t *istate)
 {
-	region_register_t rr;
-	rid_t rid;
 	uintptr_t va;
 	pte_t *t;
 	
 	va = istate->cr_ifa;  /* faulting address */
-	rr.word = rr_read(VA2VRN(va));
-	rid = rr.map.rid;
 	
 	page_table_lock(AS, true);
-	t = page_mapping_find(AS, va);
+	t = page_mapping_find(AS, va, true);
 	ASSERT(t);
 	
Index: kernel/arch/ia64/src/proc/scheduler.c
===================================================================
--- kernel/arch/ia64/src/proc/scheduler.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/proc/scheduler.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -79,4 +79,7 @@
 	 * Record address of kernel stack to bank 0 r23.
 	 * These values will be found there after switch from userspace.
+	 *
+	 * Mind the 1:1 split of the entire STACK_SIZE long region between the
+	 * memory stack and the RSE stack.
 	 */
 	asm volatile (
@@ -86,6 +89,6 @@
 		"bsw.1\n"
 		:
-		: "r" (&THREAD->kstack[THREAD_STACK_SIZE]),
-		  "r" (&THREAD->kstack[THREAD_STACK_SIZE - SP_DELTA])
+		: "r" (&THREAD->kstack[STACK_SIZE / 2]),
+		  "r" (&THREAD->kstack[STACK_SIZE / 2 - SP_DELTA])
 		);
 }
Index: kernel/arch/ia64/src/start.S
===================================================================
--- kernel/arch/ia64/src/start.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/ia64/src/start.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -174,7 +174,7 @@
 	
 	# Initialize gp (Global Pointer) register
-	movl gp = kernel_image_start
+	movl gp = __gp
 	
-	#	
+	#
 	# Initialize bootinfo on BSP.
 	#
Index: kernel/arch/mips32/Makefile.inc
===================================================================
--- kernel/arch/mips32/Makefile.inc	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/Makefile.inc	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -29,5 +29,5 @@
 BFD_ARCH = mips
 BFD = binary
-GCC_CFLAGS += -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3
+GCC_CFLAGS += -mno-abicalls -G 0 -fno-zero-initialized-in-bss -mips3 -mabi=32
 
 BITS = 32
Index: kernel/arch/mips32/include/atomic.h
===================================================================
--- kernel/arch/mips32/include/atomic.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/atomic.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -91,4 +91,5 @@
 		"	sc %0, %1\n"
 		"	beqz %0, 1b\n"
+		"	nop\n"
 		"2:\n"
 		: "=&r" (tmp),
Index: kernel/arch/mips32/include/context_offset.h
===================================================================
--- kernel/arch/mips32/include/context_offset.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/context_offset.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -63,119 +63,126 @@
 #ifdef __ASM__
 
+#ifdef KERNEL
+
 #include <arch/asm/regname.h>
 
-# ctx: address of the structure with saved context
+#else /* KERNEL */
+
+#include <libarch/regname.h>
+
+#endif /* KERNEL */
+
+/* ctx: address of the structure with saved context */
 .macro CONTEXT_SAVE_ARCH_CORE ctx:req
-	sw $s0,OFFSET_S0(\ctx)
-	sw $s1,OFFSET_S1(\ctx)
-	sw $s2,OFFSET_S2(\ctx)
-	sw $s3,OFFSET_S3(\ctx)
-	sw $s4,OFFSET_S4(\ctx)
-	sw $s5,OFFSET_S5(\ctx)
-	sw $s6,OFFSET_S6(\ctx)
-	sw $s7,OFFSET_S7(\ctx)
-	sw $s8,OFFSET_S8(\ctx)
-	sw $gp,OFFSET_GP(\ctx)
-
+	sw $s0, OFFSET_S0(\ctx)
+	sw $s1, OFFSET_S1(\ctx)
+	sw $s2, OFFSET_S2(\ctx)
+	sw $s3, OFFSET_S3(\ctx)
+	sw $s4, OFFSET_S4(\ctx)
+	sw $s5, OFFSET_S5(\ctx)
+	sw $s6, OFFSET_S6(\ctx)
+	sw $s7, OFFSET_S7(\ctx)
+	sw $s8, OFFSET_S8(\ctx)
+	sw $gp, OFFSET_GP(\ctx)
+	
 #ifndef KERNEL
-	sw $k1,OFFSET_TLS(\ctx)
-
+	sw $k1, OFFSET_TLS(\ctx)
+	
 #ifdef CONFIG_FPU
-	mfc1 $t0,$20
+	mfc1 $t0, $20
 	sw $t0, OFFSET_F20(\ctx)
-
-	mfc1 $t0,$21
+	
+	mfc1 $t0, $21
 	sw $t0, OFFSET_F21(\ctx)
-
-	mfc1 $t0,$22
+	
+	mfc1 $t0, $22
 	sw $t0, OFFSET_F22(\ctx)
-
-	mfc1 $t0,$23
+	
+	mfc1 $t0, $23
 	sw $t0, OFFSET_F23(\ctx)
-
-	mfc1 $t0,$24
+	
+	mfc1 $t0, $24
 	sw $t0, OFFSET_F24(\ctx)
-
-	mfc1 $t0,$25
+	
+	mfc1 $t0, $25
 	sw $t0, OFFSET_F25(\ctx)
-
-	mfc1 $t0,$26
+	
+	mfc1 $t0, $26
 	sw $t0, OFFSET_F26(\ctx)
-
-	mfc1 $t0,$27
+	
+	mfc1 $t0, $27
 	sw $t0, OFFSET_F27(\ctx)
-
-	mfc1 $t0,$28
+	
+	mfc1 $t0, $28
 	sw $t0, OFFSET_F28(\ctx)
-
-	mfc1 $t0,$29
+	
+	mfc1 $t0, $29
 	sw $t0, OFFSET_F29(\ctx)
 	
-	mfc1 $t0,$30
+	mfc1 $t0, $30
 	sw $t0, OFFSET_F30(\ctx)
 #endif /* CONFIG_FPU */
 #endif /* KERNEL */
-
-	sw $ra,OFFSET_PC(\ctx)
-	sw $sp,OFFSET_SP(\ctx)
+	
+	sw $ra, OFFSET_PC(\ctx)
+	sw $sp, OFFSET_SP(\ctx)
 .endm
 
-# ctx: address of the structure with saved context
+/* ctx: address of the structure with saved context */
 .macro CONTEXT_RESTORE_ARCH_CORE ctx:req
-	lw $s0,OFFSET_S0(\ctx)
-	lw $s1,OFFSET_S1(\ctx)
-	lw $s2,OFFSET_S2(\ctx)
-	lw $s3,OFFSET_S3(\ctx)
-	lw $s4,OFFSET_S4(\ctx)
-	lw $s5,OFFSET_S5(\ctx)
-	lw $s6,OFFSET_S6(\ctx)
-	lw $s7,OFFSET_S7(\ctx)
-	lw $s8,OFFSET_S8(\ctx)
-	lw $gp,OFFSET_GP(\ctx)
+	lw $s0, OFFSET_S0(\ctx)
+	lw $s1, OFFSET_S1(\ctx)
+	lw $s2, OFFSET_S2(\ctx)
+	lw $s3, OFFSET_S3(\ctx)
+	lw $s4, OFFSET_S4(\ctx)
+	lw $s5, OFFSET_S5(\ctx)
+	lw $s6, OFFSET_S6(\ctx)
+	lw $s7, OFFSET_S7(\ctx)
+	lw $s8, OFFSET_S8(\ctx)
+	lw $gp, OFFSET_GP(\ctx)
 #ifndef KERNEL
-	lw $k1,OFFSET_TLS(\ctx)
-
+	lw $k1, OFFSET_TLS(\ctx)
+	
 #ifdef CONFIG_FPU
 	lw $t0, OFFSET_F20(\ctx)
-	mtc1 $t0,$20
-
+	mtc1 $t0, $20
+	
 	lw $t0, OFFSET_F21(\ctx)
-	mtc1 $t0,$21
-
+	mtc1 $t0, $21
+	
 	lw $t0, OFFSET_F22(\ctx)
-	mtc1 $t0,$22
-
+	mtc1 $t0, $22
+	
 	lw $t0, OFFSET_F23(\ctx)
-	mtc1 $t0,$23
-
+	mtc1 $t0, $23
+	
 	lw $t0, OFFSET_F24(\ctx)
-	mtc1 $t0,$24
-
+	mtc1 $t0, $24
+	
 	lw $t0, OFFSET_F25(\ctx)
-	mtc1 $t0,$25
-
+	mtc1 $t0, $25
+	
 	lw $t0, OFFSET_F26(\ctx)
-	mtc1 $t0,$26
-
+	mtc1 $t0, $26
+	
 	lw $t0, OFFSET_F27(\ctx)
-	mtc1 $t0,$27
-
+	mtc1 $t0, $27
+	
 	lw $t0, OFFSET_F28(\ctx)
-	mtc1 $t0,$28
-
+	mtc1 $t0, $28
+	
 	lw $t0, OFFSET_F29(\ctx)
-	mtc1 $t0,$29
-
+	mtc1 $t0, $29
+	
 	lw $t0, OFFSET_F30(\ctx)
-	mtc1 $t0,$30
+	mtc1 $t0, $30
 #endif /* CONFIG_FPU */
 #endif /* KERNEL */
-
-	lw $ra,OFFSET_PC(\ctx)
-	lw $sp,OFFSET_SP(\ctx)
+	
+	lw $ra, OFFSET_PC(\ctx)
+	lw $sp, OFFSET_SP(\ctx)
 .endm
 
-#endif
-
+#endif /* __ASM__ */
 
 #endif
Index: kernel/arch/mips32/include/cp0.h
===================================================================
--- kernel/arch/mips32/include/cp0.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/cp0.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,10 +36,4 @@
 #define KERN_mips32_CP0_H_
 
-#ifdef KERNEL
-#include <typedefs.h>
-#else
-#include <sys/types.h>
-#endif
-
 #define cp0_status_ie_enabled_bit     (1 << 0)
 #define cp0_status_exl_exception_bit  (1 << 1)
@@ -49,33 +43,50 @@
 #define cp0_status_fpu_bit            (1 << 29)
 
-#define cp0_status_im_shift		8
-#define cp0_status_im_mask              0xff00
+#define cp0_status_im_shift  8
+#define cp0_status_im_mask   0xff00
 
-#define cp0_cause_excno(cause) ((cause >> 2) & 0x1f)
-#define cp0_cause_coperr(cause) ((cause >> 28) & 0x3)
+#define cp0_cause_excno(cause)   ((cause >> 2) & 0x1f)
+#define cp0_cause_coperr(cause)  ((cause >> 28) & 0x3)
 
-#define fpu_cop_id 1
+#define fpu_cop_id  1
 
 /*
  * Magic value for use in msim.
  */
-#define cp0_compare_value 		100000
+#define cp0_compare_value  100000
 
-#define cp0_mask_all_int() cp0_status_write(cp0_status_read() & ~(cp0_status_im_mask))
-#define cp0_unmask_all_int() cp0_status_write(cp0_status_read() | cp0_status_im_mask)
-#define cp0_mask_int(it) cp0_status_write(cp0_status_read() & ~(1 << (cp0_status_im_shift + (it))))
-#define cp0_unmask_int(it) cp0_status_write(cp0_status_read() | (1 << (cp0_status_im_shift + (it))))
+#define cp0_mask_all_int() \
+	cp0_status_write(cp0_status_read() & ~(cp0_status_im_mask))
 
-#define GEN_READ_CP0(nm,reg) static inline uint32_t cp0_ ##nm##_read(void) \
-  { \
-      uint32_t retval; \
-      asm("mfc0 %0, $" #reg : "=r"(retval)); \
-      return retval; \
-  }
+#define cp0_unmask_all_int() \
+	cp0_status_write(cp0_status_read() | cp0_status_im_mask)
 
-#define GEN_WRITE_CP0(nm,reg) static inline void cp0_ ##nm##_write(uint32_t val) \
- { \
-    asm("mtc0 %0, $" #reg : : "r"(val) ); \
- }
+#define cp0_mask_int(it) \
+	cp0_status_write(cp0_status_read() & ~(1 << (cp0_status_im_shift + (it))))
+
+#define cp0_unmask_int(it) \
+	cp0_status_write(cp0_status_read() | (1 << (cp0_status_im_shift + (it))))
+
+#define GEN_READ_CP0(nm, reg) \
+	static inline uint32_t cp0_ ##nm##_read(void) \
+	{ \
+		uint32_t retval; \
+		\
+		asm volatile ( \
+			"mfc0 %0, $" #reg \
+			: "=r"(retval) \
+		); \
+		\
+		return retval; \
+	}
+
+#define GEN_WRITE_CP0(nm, reg) \
+	static inline void cp0_ ##nm##_write(uint32_t val) \
+	{ \
+		asm volatile ( \
+			"mtc0 %0, $" #reg \
+			:: "r"(val) \
+		); \
+	}
 
 GEN_READ_CP0(index, 0);
Index: kernel/arch/mips32/include/cycle.h
===================================================================
--- kernel/arch/mips32/include/cycle.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/cycle.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup mips2
+/** @addtogroup mips32
  * @{
  */
Index: kernel/arch/mips32/include/debug.h
===================================================================
--- kernel/arch/mips32/include/debug.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/debug.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -34,5 +34,5 @@
 
 #ifndef KERN_mips32_DEBUG_H_
-#define KERN_mips23_DEBUG_H_
+#define KERN_mips32_DEBUG_H_
 
 /** Enter the simulator trace mode */
Index: kernel/arch/mips32/include/istate.h
===================================================================
--- kernel/arch/mips32/include/istate.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/istate.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -36,13 +36,15 @@
 #define KERN_mips32_ISTATE_H_
 
+#include <trace.h>
+
+#ifdef KERNEL
+
 #include <arch/cp0.h>
 
-#ifdef KERNEL
-#include <typedefs.h>
-#include <trace.h>
-#else
-#include <sys/types.h>
-#define NO_TRACE
-#endif
+#else /* KERNEL */
+
+#include <libarch/cp0.h>
+
+#endif /* KERNEL */
 
 typedef struct istate {
Index: kernel/arch/mips32/include/mm/as.h
===================================================================
--- kernel/arch/mips32/include/mm/as.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/mm/as.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -38,10 +38,8 @@
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
 
-#define KERNEL_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x80000000
-#define KERNEL_ADDRESS_SPACE_END_ARCH		(unsigned long) 0x9fffffff
-#define USER_ADDRESS_SPACE_START_ARCH		(unsigned long) 0x00000000
-#define USER_ADDRESS_SPACE_END_ARCH		(unsigned long) 0x7fffffff
-
-#define USTACK_ADDRESS_ARCH	(0x80000000 - PAGE_SIZE)
+#define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
+#define KERNEL_ADDRESS_SPACE_END_ARCH    UINT32_C(0x9fffffff)
+#define USER_ADDRESS_SPACE_START_ARCH    UINT32_C(0x00000000)
+#define USER_ADDRESS_SPACE_END_ARCH      UINT32_C(0x7fffffff)
 
 typedef struct {
Index: kernel/arch/mips32/include/mm/frame.h
===================================================================
--- kernel/arch/mips32/include/mm/frame.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/mm/frame.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,8 +39,5 @@
 #define FRAME_SIZE   (1 << FRAME_WIDTH)
 
-#ifdef KERNEL
 #ifndef __ASM__
-
-#include <typedefs.h>
 
 extern void frame_arch_init(void);
@@ -48,5 +45,4 @@
 
 #endif /* __ASM__ */
-#endif /* KERNEL */
 
 #endif
Index: kernel/arch/mips32/include/mm/page.h
===================================================================
--- kernel/arch/mips32/include/mm/page.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/mm/page.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -49,6 +49,4 @@
 #	define PA2KA(x)	((x) + 0x80000000)
 #endif
-
-#ifdef KERNEL
 
 /*
@@ -188,6 +186,4 @@
 #endif /* __ASM__ */
 
-#endif /* KERNEL */
-
 #endif
 
Index: kernel/arch/mips32/include/stack.h
===================================================================
--- kernel/arch/mips32/include/stack.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/stack.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -39,12 +39,4 @@
 #define STACK_ALIGNMENT		8
 
-#define STACK_ARG0		0
-#define STACK_ARG1		4
-#define STACK_ARG2		8
-#define STACK_ARG3		12
-#define STACK_ARG4		16
-#define STACK_ARG5		20
-#define STACK_ARG6		24
-
 #endif
 
Index: kernel/arch/mips32/include/types.h
===================================================================
--- kernel/arch/mips32/include/types.h	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/include/types.h	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -37,4 +37,5 @@
 
 typedef uint32_t size_t;
+typedef int32_t ssize_t;
 
 typedef uint32_t uintptr_t;
Index: kernel/arch/mips32/src/asm.S
===================================================================
--- kernel/arch/mips32/src/asm.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/asm.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -57,20 +57,8 @@
 	nop
 
-.global memsetb
-memsetb:
-	j _memsetb
-	nop
-
-.global memsetw
-memsetw:
-	j _memsetw
-	nop
-
-.global memcpy
 .global memcpy_from_uspace
 .global memcpy_to_uspace
 .global memcpy_from_uspace_failover_address
 .global memcpy_to_uspace_failover_address
-memcpy:
 memcpy_from_uspace:
 memcpy_to_uspace:
Index: kernel/arch/mips32/src/debugger.c
===================================================================
--- kernel/arch/mips32/src/debugger.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/debugger.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -79,5 +79,5 @@
 static cmd_info_t addbkpt_info = {
 	.name = "addbkpt",
-	.description = "Add bkpoint (break on J/Branch insts unsupported).",
+	.description = "Add bkpoint (break on j/branch insts unsupported).",
 	.func = cmd_add_breakpoint,
 	.argc = 1,
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/exception.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -74,8 +74,7 @@
 void istate_decode(istate_t *istate)
 {
-	printf("epc=%p\tsta=%#010" PRIx32 "\t"
+	printf("epc=%#010" PRIx32 "\tsta=%#010" PRIx32 "\t"
 	    "lo =%#010" PRIx32 "\thi =%#010" PRIx32 "\n",
-	    (void *) istate->epc, istate->status,
-	    istate->lo, istate->hi);
+	    istate->epc, istate->status, istate->lo, istate->hi);
 	
 	printf("a0 =%#010" PRIx32 "\ta1 =%#010" PRIx32 "\t"
@@ -107,7 +106,7 @@
 	    istate->s8, istate->at, istate->kt0, istate->kt1);
 	
-	printf("sp =%p\tra =%p\tgp =%p\n",
-	    (void *) istate->sp, (void *) istate->ra,
-	    (void *) istate->gp);
+	printf("sp =%#010" PRIx32 "\tra =%#010" PRIx32 "\t"
+	    "gp =%#010" PRIx32 "\n",
+	    istate->sp, istate->ra, istate->gp);
 }
 
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/mips32.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -41,5 +41,5 @@
 #include <memstr.h>
 #include <proc/thread.h>
-#include <proc/uarg.h>
+#include <abi/proc/uarg.h>
 #include <print.h>
 #include <console/console.h>
@@ -52,5 +52,5 @@
 #include <arch/debugger.h>
 #include <genarch/fb/fb.h>
-#include <genarch/fb/visuals.h>
+#include <abi/fb/visuals.h>
 #include <genarch/drivers/dsrln/dsrlnin.h>
 #include <genarch/drivers/dsrln/dsrlnout.h>
@@ -220,5 +220,5 @@
 	    cp0_status_um_bit | cp0_status_ie_enabled_bit));
 	cp0_epc_write((uintptr_t) kernel_uarg->uspace_entry);
-	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack + PAGE_SIZE), 
+	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack + STACK_SIZE),
 	    (uintptr_t) kernel_uarg->uspace_uarg,
 	    (uintptr_t) kernel_uarg->uspace_entry);
@@ -235,6 +235,6 @@
 void before_thread_runs_arch(void)
 {
-	supervisor_sp = (uintptr_t) &THREAD->kstack[THREAD_STACK_SIZE -
-	    SP_DELTA];
+	supervisor_sp =
+	    (uintptr_t) &THREAD->kstack[STACK_SIZE - SP_DELTA];
 }
 
Index: kernel/arch/mips32/src/mm/frame.c
===================================================================
--- kernel/arch/mips32/src/mm/frame.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/mm/frame.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -88,5 +88,5 @@
 	/* gxemul devices */
 	if (overlaps(frame << ZERO_PAGE_WIDTH, ZERO_PAGE_SIZE,
-	    0x10000000, MB2SIZE(256)))
+	    0x10000000, MiB2SIZE(256)))
 		return false;
 #endif
Index: kernel/arch/mips32/src/mm/tlb.c
===================================================================
--- kernel/arch/mips32/src/mm/tlb.c	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/mm/tlb.c	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -73,5 +73,5 @@
 		tlbwi();
 	}
-		
+	
 	/*
 	 * The kernel is going to make use of some wired
@@ -99,6 +99,4 @@
 	asid = AS->asid;
 	mutex_unlock(&AS->lock);
-	
-	page_table_lock(AS, true);
 	
 	pte = find_mapping_and_check(badvaddr, PF_ACCESS_READ, istate, &pfrc);
@@ -113,5 +111,4 @@
 			 * or copy_to_uspace().
 			 */
-			page_table_unlock(AS, true);
 			return;
 		default:
@@ -144,9 +141,7 @@
 	tlbwr();
 
-	page_table_unlock(AS, true);
 	return;
 	
 fail:
-	page_table_unlock(AS, true);
 	tlb_refill_fail(istate);
 }
@@ -176,6 +171,4 @@
 	index.value = cp0_index_read();
 
-	page_table_lock(AS, true);	
-	
 	/*
 	 * Fail if the entry is not in TLB.
@@ -197,5 +190,4 @@
 			 * or copy_to_uspace().
 			 */
-			page_table_unlock(AS, true);			 
 			return;
 		default:
@@ -227,9 +219,7 @@
 	tlbwi();
 
-	page_table_unlock(AS, true);
 	return;
 	
 fail:
-	page_table_unlock(AS, true);
 	tlb_invalid_fail(istate);
 }
@@ -259,6 +249,4 @@
 	index.value = cp0_index_read();
 
-	page_table_lock(AS, true);	
-	
 	/*
 	 * Fail if the entry is not in TLB.
@@ -280,5 +268,4 @@
 			 * or copy_to_uspace().
 			 */
-			page_table_unlock(AS, true);			 
 			return;
 		default:
@@ -311,9 +298,7 @@
 	tlbwi();
 
-	page_table_unlock(AS, true);
 	return;
 	
 fail:
-	page_table_unlock(AS, true);
 	tlb_modified_fail(istate);
 }
@@ -364,6 +349,4 @@
 	pte_t *pte;
 
-	ASSERT(mutex_locked(&AS->lock));
-
 	hi.value = cp0_entry_hi_read();
 
@@ -379,5 +362,5 @@
 	 * Check if the mapping exists in page tables.
 	 */	
-	pte = page_mapping_find(AS, badvaddr);
+	pte = page_mapping_find(AS, badvaddr, true);
 	if (pte && pte->p && (pte->w || access != PF_ACCESS_WRITE)) {
 		/*
@@ -393,5 +376,4 @@
 		 * Resort to higher-level page fault handler.
 		 */
-		page_table_unlock(AS, true);
 		switch (rc = as_page_fault(badvaddr, access, istate)) {
 		case AS_PF_OK:
@@ -400,20 +382,14 @@
 			 * The mapping ought to be in place.
 			 */
-			page_table_lock(AS, true);
-			pte = page_mapping_find(AS, badvaddr);
+			pte = page_mapping_find(AS, badvaddr, true);
 			ASSERT(pte && pte->p);
 			ASSERT(pte->w || access != PF_ACCESS_WRITE);
 			return pte;
-			break;
 		case AS_PF_DEFER:
-			page_table_lock(AS, true);
 			*pfrc = AS_PF_DEFER;
 			return NULL;
-			break;
 		case AS_PF_FAULT:
-			page_table_lock(AS, true);
 			*pfrc = AS_PF_FAULT;
 			return NULL;
-			break;
 		default:
 			panic("Unexpected rc (%d).", rc);
Index: kernel/arch/mips32/src/start.S
===================================================================
--- kernel/arch/mips32/src/start.S	(revision 667a4f84d6f4121641eb400329f6775769df3b1b)
+++ kernel/arch/mips32/src/start.S	(revision abf04a54e4c7aacff4953360924ae064a6a0fc91)
@@ -222,6 +222,5 @@
 	
 	/* move $k0 pointer to kernel stack */
-	lui $k0, %hi(supervisor_sp)
-	ori $k0, $k0, %lo(supervisor_sp)
+	la $k0, supervisor_sp
 	
 	/* move $k0 (supervisor_sp) */
